com.holonplatform.vaadin.components.builders

## Interface ItemListingBuilder.GridItemListingBuilder<T,C extends ItemListing<T,String>,B extends ItemListingBuilder.GridItemListingBuilder<T,C,B>>

- Type Parameters:
    `T` - Item data type
    `C` - Listing component type
    `B` - Concrete builder type
  All Superinterfaces:
    BaseItemDataSourceComponentBuilder<B>, ComponentBuilder<C,B>, ComponentConfigurator<B>, ComponentPostProcessorSupport<com.vaadin.ui.Grid<T>,B>, ItemDataSourceComponentBuilder<T,C,B>, ItemListingBuilder<T,String,C,B,com.vaadin.ui.Grid<T>>, ItemListingBuilder.BaseGridItemListingBuilder<T,String,C,B>
  All Known Subinterfaces:
    BeanListingBuilder<T>
  Enclosing interface:
    ItemListingBuilder<T,P,C extends ItemListing<T,P>,B extends ItemListingBuilder<T,P,C,B,X>,X extends com.vaadin.ui.Component>

      public static interface ItemListingBuilder.GridItemListingBuilder<T,C extends ItemListing<T,String>,B extends ItemListingBuilder.GridItemListingBuilder<T,C,B>>
      extends ItemListingBuilder.BaseGridItemListingBuilder<T,String,C,B>

  Builder to create an `ItemListing` with a `Grid` as backing component.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.holonplatform.vaadin.components.builders.ItemListingBuilder

      `ItemListingBuilder.BaseGridItemListingBuilder<T,P,C extends ItemListing<T,P>,B extends ItemListingBuilder.BaseGridItemListingBuilder<T,P,C,B>>, ItemListingBuilder.ColumnHeaderMode, ItemListingBuilder.FooterBuilder<P>, ItemListingBuilder.GridFooterGenerator<T,P>, ItemListingBuilder.GridItemListingBuilder<T,C extends ItemListing<T,String>,B extends ItemListingBuilder.GridItemListingBuilder<T,C,B>>, ItemListingBuilder.GridSection<ROWTYPE>, ItemListingBuilder.HeaderBuilder<P>, ItemListingBuilder.ListingFooterRow<P>, ItemListingBuilder.ListingHeaderRow<P>`

    - ### Nested classes/interfaces inherited from interface com.holonplatform.vaadin.components.builders.ComponentConfigurator

      `ComponentConfigurator.BaseComponentConfigurator`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `B` | `dataSource(com.holonplatform.core.datastore.Datastore datastore, com.holonplatform.core.datastore.DataTarget<?> target)` Set given `Datastore` as data source, using given data target to perform queries and obtain the listing items as beans of the required type.
    `default <ITEM> B` | `dataSource(ItemDataProvider<ITEM> dataProvider, Function<ITEM,T> converter)` Set the item listing data source using an `ItemDataProvider` and function to convert data source items into required item type.
    `<E extends com.vaadin.data.HasValue<?> & com.vaadin.ui.Component> B` | `editor(String property, E editor)` Set the field to use for given property in edit mode.
    `B` | `render(String property, com.vaadin.ui.renderers.Renderer<?> renderer)` Set a custom `Renderer` for given item property.
    `<V,P> B` | `render(String property, com.vaadin.data.ValueProvider<V,P> presentationProvider, com.vaadin.ui.renderers.Renderer<? super P> renderer)` Set a custom `Renderer` and presentation provider for given item property.
    `default B` | `withValidator(String property, com.holonplatform.core.Validator<?> validator)` Adds a `Validator` to the field bound to given `property` in the item listing editor.
    `B` | `withValidator(String property, com.vaadin.data.Validator<?> validator)` Adds a `Validator` to the field bound to given `property` in the item listing editor.

    - ### Methods inherited from interface com.holonplatform.vaadin.components.builders.ItemListingBuilder.BaseGridItemListingBuilder

      `commitOnRemove, commitOnSave, detailsGenerator, editorBuffered, editorCancelCaption, editorCancelCaption, editorCancelCaption, editorErrorGenerator, editorSaveCaption, editorSaveCaption, editorSaveCaption, expandRatio, footer, footerGenerator, frozenColumns, header, headerHTML, headerHTML, headerHTML, headerMode, heightByContents, heightByRows, hidingToggleCaption, hidingToggleCaption, hidingToggleCaption, maxWidth, minimumWidthFromContent, minWidth, required, required, required, required, resizable, withEditorCancelListener, withEditorOpenListener, withEditorSaveListener, withValidator, withValidator`

    - ### Methods inherited from interface com.holonplatform.vaadin.components.builders.ItemListingBuilder

      `alignment, bodyRowHeight, buffered, build, build, columnHidingAllowed, columnReorderingAllowed, commitHandler, defaultValue, displayAfter, displayAsFirst, displayAsLast, displayBefore, editable, editable, footerRowHeight, footerVisible, header, header, header, headerRowHeight, hidable, hidden, hideHeaders, itemDescriptionGenerator, readOnly, rowHeight, selectAllCheckBoxVisibility, selectionMode, sortable, sortable, sortGenerator, sortUsing, style, style, width, withItemClickListener, withPropertyReorderListener, withPropertyResizeListener, withPropertyVisibilityListener, withRowStyle, withSelectionListener`

    - ### Methods inherited from interface com.holonplatform.vaadin.components.builders.ItemDataSourceComponentBuilder

      `dataSource, dataSource`

    - ### Methods inherited from interface com.holonplatform.vaadin.components.builders.BaseItemDataSourceComponentBuilder

      `autoRefresh, batchSize, defaultSort, fixedFilter, fixedSort, maxCacheSize, queryParameter, withQueryConfigurationProvider`

    - ### Methods inherited from interface com.holonplatform.vaadin.components.builders.ComponentBuilder

      `build, deferLocalization, dragSource, dropTarget`

    - ### Methods inherited from interface com.holonplatform.vaadin.components.builders.ComponentConfigurator

      `caption, caption, caption, captionAsHtml, description, description, description, disabled, errorHandler, fullHeight, fullSize, fullWidth, height, height, heightUndefined, hidden, icon, id, notVisible, primaryStyleName, replaceStyleName, responsive, sizeUndefined, styleName, width, width, widthUndefined, withAttachListener, withContextClickListener, withData, withDetachListener, withShortcutListener`

    - ### Methods inherited from interface com.holonplatform.vaadin.components.builders.ComponentPostProcessorSupport

      `withPostProcessor`

- - ### Method Detail

    - #### dataSource

          B dataSource(com.holonplatform.core.datastore.Datastore datastore,
                       com.holonplatform.core.datastore.DataTarget<?> target)

      Set given `Datastore` as data source, using given data target to perform queries and obtain the listing items as beans of the required type.
      Parameters:
        `datastore` - The Datastore to use (not null)
        `target` - The data target to use (not null)
      Returns:
        this

    - #### dataSource

          default <ITEM> B dataSource(ItemDataProvider<ITEM> dataProvider,
                                      Function<ITEM,T> converter)

      Set the item listing data source using an `ItemDataProvider` and function to convert data source items into required item type.
      Type Parameters:
        `ITEM` - Item type
      Parameters:
        `dataProvider` - Item data provider (not null)
        `converter` - Item converter (not null)
      Returns:
        this

    - #### editor

          <E extends com.vaadin.data.HasValue<?> & com.vaadin.ui.Component> B editor(String property,
                                                                                     E editor)

      Set the field to use for given property in edit mode.
      Type Parameters:
        `E` - Editor field type
      Parameters:
        `property` - Item property to set the editor for (not null)
        `editor` - Editor field (not null)
      Returns:
        this

    - #### withValidator

          default B withValidator(String property,
                                  com.holonplatform.core.Validator<?> validator)

      Adds a `Validator` to the field bound to given `property` in the item listing editor.
      Parameters:
        `property` - Property (not null)
        `validator` - Validator to add (not null)
      Returns:
        this

    - #### withValidator

          B withValidator(String property,
                          com.vaadin.data.Validator<?> validator)

      Adds a `Validator` to the field bound to given `property` in the item listing editor.
      Parameters:
        `property` - Property (not null)
        `validator` - Validator to add (not null)
      Returns:
        this

    - #### render

          B render(String property,
                   com.vaadin.ui.renderers.Renderer<?> renderer)

      Set a custom `Renderer` for given item property.
      Parameters:
        `property` - Item property to set the renderer for (not null)
        `renderer` - Renderer to use
      Returns:
        this

    - #### render

          <V,P> B render(String property,
                         com.vaadin.data.ValueProvider<V,P> presentationProvider,
                         com.vaadin.ui.renderers.Renderer<? super P> renderer)

      Set a custom `Renderer` and presentation provider for given item property.
      Type Parameters:
        `V` - Property value type
        `P` - Presentation value type
      Parameters:
        `property` - Item property to set the renderer for
        `presentationProvider` - Presentation provider
        `renderer` - Renderer to use
      Returns:
        this

Copyright © 2019 The Holon Platform. All rights reserved.